using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// Summary description for LookUpForm.
	/// </summary>
	public class LookUpForm : System.Windows.Forms.Form
	{
		private IRMComponent m_irm;
		private TreeNode m_selectedNode;

		private bool m_bDrawn = false;
		private Util util;
		private ClientSession m_session;

		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mnuSelectItem;
		private System.ComponentModel.IContainer components;

		public LookUpForm(ClientSession session, Control parent)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			util = new Util(this,parent);
			m_session = session;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LookUpForm));
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mnuSelectItem = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// treeView1
			// 
			this.treeView1.ContextMenu = this.contextMenu1;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeView1.ImageList = this.imageList1;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.Size = new System.Drawing.Size(368, 357);
			this.treeView1.TabIndex = 0;
			this.treeView1.BeforeExpand += new System.Windows.Forms.TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.mnuSelectItem});
			// 
			// mnuSelectItem
			// 
			this.mnuSelectItem.Index = 0;
			this.mnuSelectItem.Text = "Select";
			this.mnuSelectItem.Click += new System.EventHandler(this.mnuSelectItem_Click);
			// 
			// LookUpForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 357);
			this.Controls.Add(this.treeView1);
			this.Name = "LookUpForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "File Plan Look Up";
			this.Load += new System.EventHandler(this.LookUpForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void LookUpForm_Load(object sender, System.EventArgs e)
		{
			if(!m_bDrawn)
			{
				CommonTasks.DrawFilePlan(m_session,treeView1);
				m_bDrawn = true;
			}
			else
			{
				CommonTasks.RefreshViews(m_session,treeView1.Nodes[0],true);
			}
		}

		private void treeView1_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			int count = e.Node.Nodes.Count;
			if(count == 1)
			{
				if(e.Node.FirstNode.Tag == null)
				{
					IRMComponent irm = (IRMComponent)e.Node.Tag;
					CommonTasks.addTargetList(m_session, e.Node,irm.FlPlnViewID,irm.FlPlnCmpntID);
				}
			}
		}

		private void mnuSelectItem_Click(object sender, System.EventArgs e)
		{
			m_irm = (IRMComponent)treeView1.SelectedNode.Tag;
			m_selectedNode = treeView1.SelectedNode;
			DialogResult = DialogResult.OK;
			this.Close();
		}

		public IRMComponent SelectedComponent
		{
			get
			{
				return m_irm;
			}
		}

		public TreeNode SelectedNode
		{
			get
			{
				return m_selectedNode;
			}
		}
	}
}
